package com.ejwa.wsbooks.resources;

import com.ejwa.wsbooks.model.Book;
import com.ejwa.wsbooks.model.BookShelf;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Response;

@Path("shelf")
public class ShelfResource {
	@EJB
	private BookShelf bookShelf;

	@GET // curl -X GET --basic http://localhost:8080/wsbooks/ws/shelf
	public List<Book> list() {
		return bookShelf.getBooks();
	}

	@GET // curl -X GET --basic http://localhost:8080/wsbooks/ws/shelf/0
	@Path("{bookNum}")
	public Book get(@PathParam("bookNum") int num) {
		return bookShelf.getBooks().get(num);
	}

	@GET // curl -X GET --basic http://localhost:8080/wsbooks/ws/shelf/0/3
	@Path("{from}/{to}")
	public List<Book> range(@PathParam("from") int from, @PathParam("to") int to) {
		return bookShelf.getBooks().subList(from, to);
	}

	@PUT // curl -H "content-type: application/json" -X PUT --basic http://localhost:8080/wsbooks/ws/shelf -d '{"title":"Forever & Ever", "author":"Twiggly Johnsson"}'
	public boolean add(Book book) {
		bookShelf.getBooks().add(book);
		return true;
	}
}
